package org.wronka.matt.Okc;

import java.io.IOException;
import java.util.Date;
import java.util.Vector;
import java.net.URLEncoder;

public class Mail {
	final static String mailbox_url = "/mailbox";
	protected OKConnection c;

	public Mail(OKConnection c) {
		this.c = c;
	}

	/*
	 * Returns a listing of messages in the mailbox 
	 * (first page only currently)
	 */
	public void getMailbox(Vector v, int folder, boolean unreadOnly) throws IOException {
		getMailbox(v, folder, 0, unreadOnly);
	}
	public void getMailbox(Vector v, int folder, int page, boolean unreadOnly) throws IOException {
		boolean ignoreOkcupid=true;
		final String status_flag = "<li class=\"";
		final String from_flag = "\"/profile?u=";
		final String sysfrom_flag = "<span class=\"msgSysName\">";
		final String href_flag = "mailbox?readmsg=";
		final String date_flag = "var d = new Date (";
		StringBuffer data = new StringBuffer(1024);
		StringBuffer furl = new StringBuffer(256);
		furl.append(Mail.mailbox_url+"?folder="+folder);
		if(page>0) {
			furl.append("&next=" + page);
		}
		c.send(furl.toString(), "", "GET", data);
		int mailStart = data.indexOf("<ul id=\"messages\">");
		int mailEnd = mailStart+data.substring(mailStart).indexOf("</ul>");
		int currLoc = mailStart;
		while(currLoc < mailEnd) {
			String s = data.substring(currLoc, mailEnd);
			int msg_start = s.indexOf(status_flag);
			if(msg_start < 0) break;
			currLoc += msg_start+1;
			s = s.substring(msg_start);
			String status = s.substring(status_flag.length());
			status = status.substring(0, status.indexOf('"'));

			String url = s.substring(s.indexOf(href_flag));
			url = url.substring(0, url.indexOf('"'));
			s = s.substring(s.indexOf(url)+
					url.length()+2);
			String subject = s.substring(0, s.indexOf("</a>")).trim();

			// Status .... \n
			s = s.substring(s.indexOf('\n')+1);
			// "from\n"
			s = s.substring(s.indexOf('\n')+1);
			//  <from>
			String from = s.substring(1, s.indexOf(' ')).trim();

			s = s.substring(s.indexOf(date_flag));
			s = s.substring(date_flag.length());
			s = s.substring(0, s.indexOf(' '));
			Date date = _parseDate(s);

			// normalize ampersands
			url = url.replaceAll("&amp;", "&");
			//System.out.println("Pulled: " + status + " " + subject + " " + from + " " + url);

			if( (!ignoreOkcupid || !"OkCupid!".equals(from)) && (!unreadOnly || status.equals("unreadMessage"))) {
				Message msg = new Message(from, url, subject);
				msg.setDate(date);
				v.add(msg);
			}
		}
		
	}

	/*
	 * Gets the message body.
	 */
	public Message retrieveBody(Message message) throws IOException {
		final String bflag = "name=\"body_to_forward\" value=\"";
		String body; 
		int bStart, bEnd;
		StringBuffer data = new StringBuffer(1024);
		c.send('/'+message.getURL(), "", "GET", data);
		bStart = data.indexOf(bflag)+bflag.length();
		bEnd = data.indexOf("\"", bStart);
		body = data.substring(bStart, bEnd);
		message.setBody(body);
		return message;
	}

	public void sendMessage(Message message) throws IOException {
		String data;
		StringBuffer resp = new StringBuffer(1024);
		data = "body="+URLEncoder.encode(message.getBody()) +
			"&authcode="+URLEncoder.encode(_getAuthCode()) +
			"&r1="+URLEncoder.encode(message.getFrom()) +
			"&subject="+URLEncoder.encode(message.getSubject()) +
			"&f2=&r2=none&folderid=1&sendmsg=Send+Message&contactflag=compose";
		c.send(mailbox_url, data, "POST", resp);
		//c.send(mailbox_url, data, "POST", null);
		//System.out.println("|"+message.getFrom()+"|");
		//System.out.println("|"+message.getSubject()+"|");
		//System.out.println(message.getBody());
		//System.out.println(resp);
	}

	private String _getAuthCode()
	{
		final String authcode = "name=\"authcode\" value=\"";
		StringBuffer data = new StringBuffer(1024);
		StringBuffer furl = new StringBuffer(256);
		furl.append(Mail.mailbox_url+"?compose=1");
		try
		{
			c.send(furl.toString(), "", "GET", data);
		} catch (IOException ioe) {
			return "";
		}
		int start = data.indexOf(authcode)+authcode.length();
		int end = data.indexOf("\"", start);
		return(new String(data.substring(start, end)));

	}

	protected Date _parseDate(String s)
	{
		try
		{
			return new Date(Long.parseLong(s) * 1000);
		}catch(Exception e)
		{
			return new Date();
		}
	}
	protected Date _old_parseDate(String s)
	{
		final String DATE_START = "\">md(";
		String date_start = s.substring(s.indexOf(DATE_START)+DATE_START.length());
		date_start = date_start.substring(0, date_start.indexOf(")"));
		String date_components[] =  date_start.split(",");
		Date rval = null;
		try
		{
			rval =
				new Date(
					Integer.parseInt(date_components[0])-1900,
					Integer.parseInt(date_components[1]),
					Integer.parseInt(date_components[2]),
					Integer.parseInt(date_components[3]),
					Integer.parseInt(date_components[4]),
					Integer.parseInt(date_components[5]) );
		} 
		catch (NumberFormatException nfe) 
		{
			System.err.println("Error parsing message date.  Defaulting to now().");
			return new Date();
		}
		return rval;
	}
}
