package org.wronka.matt.Okc;

import java.util.Date;
import java.util.Locale;
import java.text.SimpleDateFormat;

public class Message {
	protected String from; 
	protected String subject;
	protected String body;
	protected String url;
	protected Date  date;
	protected boolean bRead = false;
	protected boolean bFetchedBody = false;

	public Message(String from, String url, String subject) {
		this.from = from.replaceAll(" ", "_");
		this.url = url;
		this.subject = subject;
		this.body = null;
		this.date = new Date();
	}

	public String getFrom() { return from; }
	public String getSubject() { return subject; }
	public String getURL() { return url; }

	public void setDate(Date date) {
		this.date = date;
	}

	public Date getDate() {
		return date;
	}

	public String getFormattedDate() {
		return new SimpleDateFormat("EEE MMM dd HH:mm:ss yyyy +0000", Locale.US).format(getDate());
	}

	public void setBody(String body) {
		this.body = body;
		bFetchedBody = true;
	}

	public String getBody() {
		return body;
	}

	public void setReadStatus(boolean read) {
		this.bRead = read;
	}

	public boolean getReadStatus() {
		return this.bRead;
	}

	public boolean getHasBody() {
		return bFetchedBody;
	}
}
