package org.wronka.matt.Okc;

import java.net.Socket;
import java.net.URLEncoder;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Map.Entry;

public class OKConnection {
	final public static String server = "www.okcupid.com";
	final public static int port   = 80;
	final public static String login_url = "/login";
	final public static String ua_string = "FetchOK/0.1"; //"Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR 1.1.4322)";
	//final public static String ua_string = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR 1.1.4322)";
	protected String login = "";
	protected String pass  = "";
	protected HashMap cookies = new HashMap();

	public OKConnection(String login, String pass) {
		this.login = login;
		this.pass  = pass;
	}

	public boolean connect() {
		String content;
		content = "username=" + URLEncoder.encode(login) + 
				"&password=" + URLEncoder.encode(pass);
		content+= "&p=/home&submit=Login";
		content+= "&forever=on&splashFormRightSubmit=&loginf=";
		try {
			send(this.login_url, content, "POST", null);
		} catch (IOException ioe) {
			return false;
		}
		return true;
	}

	public boolean send(String url, String content, String method, 
			StringBuffer buf) 
		throws IOException{
		String headers = method + " " + url + " HTTP/1.0\r\n";
		headers+= "Content-Type: application/x-www-form-urlencoded\r\n";
		headers+= "Host: " + this.server + "\r\n";
		headers+= "User-Agent: " + this.ua_string + "\r\n";
		headers+= "Content-Length: " + content.length() + "\r\n";
		/* add cookies */
		Iterator cook_itr = this.cookies.entrySet().iterator();
		if(cook_itr.hasNext()) {
			headers += "Cookie:"; 
			while(cook_itr.hasNext()) {
				//Entry<String, String> me = (Entry<String,String>)cook_itr.next();
				Entry me = (Entry)cook_itr.next();
				headers += " " + (String)me.getKey() + "=" + (String)me.getValue();
				if(cook_itr.hasNext()) headers+=";";
			}
			headers+= "\r\n"; // cookies
		}
		headers+= "\r\n";

		String s; 
		Socket sock = new Socket(this.server, this.port);
		PrintWriter out = new PrintWriter(sock.getOutputStream(), true);
		BufferedReader in = new BufferedReader( new InputStreamReader(sock.getInputStream() ));

		//System.out.println(headers+content);
		out.print(headers);
		out.print(content);
		out.flush();

		boolean bHeaders = true;
		final String set_cookie = "Set-Cookie:";
		while((s=in.readLine()) != null) {
		//	System.out.println(s);
			if(bHeaders) {
				if(s.trim().equals("")) {
					bHeaders = false;
				} else {
					if(s.length()>= set_cookie.length() &&
						set_cookie.equalsIgnoreCase(
							s.substring(0, 
							set_cookie.length()))) {
						String key, value;
						String[] kv = s.substring(
								set_cookie.length(),
								s.indexOf(';'))
							.trim().split("[;:]");
						int kveq = kv[0].indexOf('=');
						key = kv[0].substring(0, kveq);
						value = kv[0].substring(kveq+1);
						this.cookies.put(key, value);
					}
				}
				continue;
			} else {
				if(buf!=null) {
					buf.append(s+'\n');
				}
			}

		}
		return true;
	}
}
